﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;

namespace HeuristicLab.DataPreprocessing {
  public interface IManipulationLogic {
    void ReOrderToIndices(IEnumerable<int> indices);
    void ReOrderToIndices(IList<Tuple<int, int>> indices);
    void ReplaceIndicesByAverageValue(int columnIndex, IEnumerable<int> rowIndices);
    void ReplaceIndicesByLinearInterpolationOfNeighbours(int columnIndex, IEnumerable<int> rowIndices);
    void ReplaceIndicesByMedianValue(int columnIndex, IEnumerable<int> rowIndices);
    void ReplaceIndicesByMostCommonValue(int columnIndex, IEnumerable<int> rowIndices);
    void ReplaceIndicesByRandomValue(int columnIndex, IEnumerable<int> rowIndices);
    void ReplaceIndicesByValue<T>(int columnIndex, IEnumerable<int> rowIndices, T value);
    void ShuffleWithRanges(IEnumerable<HeuristicLab.Data.IntRange> ranges);
  }
}
